#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#include "game_ar.h"
#include "niveau.h"
#include "input_move.h"

void afficher(game g){
  int width = game_width(g);
  int height = game_height(g);
  int matrice[height][width];
  for(int i = 0; i < height; i++){
    for(int j = 0; j < width; j++){
      matrice[i][j] = -1;
    }
  }
  for(int i = 0; i < game_nb_pieces(g); i++){
    cpiece p = game_piece(g, i);
    int x = get_x(p);
    int y = get_y(p);
    for(int j = 0; j < get_width(p); j++){
      for(int k = 0; k < get_height(p); k++)
	matrice[y+k][x+j] = i;
    }
  }
  printf(" ");
  for(int t = 0; t < width; t++)
    printf("####");
  printf("\n");
  for(int i = height-1; i >= 0 ; i--){
    printf("|");
    for(int j = 0; j < width; j++){
      if(matrice[i][j] == -1){
	printf(" .. ");
      } else {
	printf(" %2d ", matrice[i][j]);
      }
      
    }
    printf("|");
    printf("\n");
  }
  printf(" ");
  for(int t = 0; t < width; t++){
    if(t != 1 && t != 2)
      printf("####");
    else
      printf("    ");
  }
  printf("\n");
  printf("Nombre de déplacement : %d\n", game_nb_moves(g));

}

void start_game(game g){
  afficher(g);
  while(!game_over_ar(g)){
    int numPiece = num_piece_mouv(g);
    dir d = direction(g, numPiece);
    int nbCase = nombre_deplacement();
    if(!play_move(g, numPiece, d, nbCase)){
      printf("MOUVEMENT IMPOSSIBLE\n");
    }
    afficher(g);
  }
  printf("Felicitations, vous avez remporté la partie !\n");
}

int main(void){
  printf("Bienvenue dans l'Âne rouge !\n");
  game g = create_game_an();
  start_game(g);
  delete_game(g);
  return EXIT_SUCCESS;
}
