#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include <ctype.h>

#include "game.h"


//fonction qui prend en paramètre un char* et qui vérifie si le paramètre est un nombre, retourne vrai si c'est le cas sinon retourne faux
bool isNumber(char *s){
  if(strlen(s)==1)
    return false;
  for(int i = 0; i < strlen(s) - 1; i++){
    if(isdigit(s[i])==0)
      return false;
  }
  return true;
}

//fonction qui va renvoyer le nombre de case dont l'utilisateur souhaite déplacer la piece
int nombre_deplacement(){
  char s[10];
  int nb = 0;
  while(nb==0){
    printf("Veuillez saisir le nombre de case dont vous voulez le déplacer :\n");
    fgets(s, 10, stdin);
    if(!isNumber(s) || atoi(s)<1){
      printf("Veuillez saisir un nombre valide\n");
      continue;
    }
    nb = atoi(s);
  }
  return nb;
}

//fonction qui prend en parametre un game et un numPiece, afin de demander dans quel direction l'utlisateur souhaite deplacer sa piece et renvoir un dir
dir direction(game g, int numPiece){
  char s[10];
  bool move_x = can_move_x(game_piece(g, numPiece));
  bool move_y = can_move_y(game_piece(g, numPiece));
  bool directionValide = false;
  dir d;
  char mouv[60] = "";
  if(move_x && move_y){
    strcat(mouv, " (L)EFT, (R)IGHT, (U)P ou (D)OWN");
  } else {
    if(move_x)
      strcat(mouv, " (L)EFT ou (R)IGHT");
    if(move_y)
      strcat(mouv, " (U)P ou (D)OWN");
  }
  while(!directionValide){
    printf("Veuillez saisir la direction du mouvement souhaité%s: \n", mouv);
    fgets(s, 10, stdin);
    s[0] = toupper(s[0]);
    if(strlen(s)!=2 ||
       (move_x && move_y && s[0]!='U' && s[0]!='D' && s[0]!='L' && s[0]!='R') ||
       (move_x && !move_y && s[0]!='L' && s[0]!='R') ||
       (move_y && !move_x && s[0]!='U' && s[0]!='D')){
      printf("Veuillez saisir une direction valide\n");
      continue;
    }
    switch (s[0]){
    case 'L':
      d = LEFT;
      break;
    case 'R':
      d = RIGHT;
      break;
    case 'U':
      d = UP;
      break;
    case 'D':
      d = DOWN;
      break;
    }
    directionValide = true;
    }
    return d;
}


//fonction qui prend en paramètre un game, afin de demander la piece qu'il souhaite déplacer et retourne le numero de cette piece
int num_piece_mouv(game g){
  int numPiece = -1;
  char s[10];
  while(numPiece==-1){
    printf("Veuillez saisir le numéro de la piece que vous souhaitez déplacer : \n");
    fgets(s, 10, stdin);
    numPiece = atoi(s);
    if(!isNumber(s) || numPiece<0 || numPiece >= game_nb_pieces(g) || (!can_move_x(game_piece(g, numPiece)) && !can_move_y(game_piece(g, numPiece)))){
      printf("Veuillez saisir un numéro valide\n");
      numPiece = -1;
      continue;
    }
  }
  return numPiece;
}
