#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#include "game.h"

//fonction qui prend en paramètre un tableau de piece et un entier contenant le nombre déléments du tableau
//cette fonction va supprimmer libérer l'espace mémoire de chaque piece du tableau en parametre
void detruire_pieces_dur(piece p[], int nbPiece){
  for(int i = 0; i < nbPiece; i++){
    delete_piece(p[i]);
  }
}

//fonction qui créé un game rush hour
//fonction qui prend en paramètre un nombre, et qui va retourner game généré grace au nombre recu en paramètre
game create_game_rh(int niveau){
  game g = NULL;
  if(niveau == 1){
    piece p[6];
    p[0] = new_piece_rh(0, 3, true, true);
    p[1] = new_piece_rh(0, 2, true, true);
    p[2] = new_piece_rh(1, 0, true, false);
    p[3] = new_piece_rh(3, 1, false, false);
    p[4] = new_piece_rh(5, 1, false, false);
    p[5] = new_piece_rh(3, 0, false, true);
    g = new_game_hr(6, p);
    detruire_pieces_dur(p, 6);  
  }
  if(niveau == 2){
    piece p[8];
    p[0] = new_piece_rh(0, 3, true, true);
    p[1] = new_piece_rh(2, 4, true, false);
    p[2] = new_piece_rh(2, 2, true, false);
    p[3] = new_piece_rh(1, 0, true, false);
    p[4] = new_piece_rh(2, 0, true, true);
    p[5] = new_piece_rh(3, 1, true, true);
    p[6] = new_piece_rh(3, 2, false, false);
    p[7] = new_piece_rh(5, 0, false, false);
    g = new_game_hr(8, p);
    detruire_pieces_dur(p, 8);  
  }
  if(niveau == 3){
    piece p[12];
    p[0] = new_piece_rh(0, 3, true, true);
    p[1] = new_piece_rh(0, 4, true, false);
    p[2] = new_piece_rh(0, 2, true, true);
    p[3] = new_piece_rh(0, 0, true, false);
    p[4] = new_piece_rh(1, 5, false, true);
    p[5] = new_piece_rh(2, 1, true, false);
    p[6] = new_piece_rh(3, 0, true, false);
    p[7] = new_piece_rh(3, 2, true, false);
    p[8] = new_piece_rh(4, 4, true, false);
    p[9] = new_piece_rh(4, 1, true, true);
    p[10] = new_piece_rh(4, 2, true, true);
    p[11] = new_piece_rh(5, 3, false, false);
    g = new_game_hr(12, p);
    detruire_pieces_dur(p, 12);    
  }
  return g;
}

//fonction qui créé un game ane rouge et qui le retourne
game create_game_an(){
  piece p[10];
  p[0] = new_piece(1, 3, 2, 2, true, true);
  p[1] = new_piece(0, 3, 1, 2, true, true);
  p[2] = new_piece(3, 3, 1, 2, true, true);
  p[3] = new_piece(0, 1, 1, 2, true, true);
  p[4] = new_piece(3, 1, 1, 2, true, true);
  p[5] = new_piece(1, 2, 2, 1, true, true);
  p[6] = new_piece(0, 0, 1, 1, true, true);
  p[7] = new_piece(1, 1, 1, 1, true, true);
  p[8] = new_piece(2, 1, 1, 1, true, true);
  p[9] = new_piece(3, 0, 1, 1, true, true);
  game g = new_game(4, 5, 10, p);
  detruire_pieces_dur(p, 10);
  return g;
}


