#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "piece.h"

//commentaires de chaque fonction de piece.c dans piece.h

struct piece_s{
  int x;
  int y;
  int width;
  int height;
  bool move_x;
  bool move_y;
};

piece new_piece_rh(int x, int y, bool small, bool horizontal){
  int width = 1;
  int height = 1;
  bool move_x = false;
  bool move_y = false;
  if(horizontal){
    move_x = true;
    if(small)
      width = 2;
    else
      width = 3;
  }else{
    move_y = true;
    if(small)
      height = 2;
    else
      height = 3;
  }
  return new_piece(x, y, width, height, move_x, move_y);
}

piece new_piece(int x, int y, int width, int height, bool move_x, bool move_y){
  piece p = (piece)malloc(sizeof(struct piece_s));
  assert(p != NULL);
  p->x = x;
  p->y = y;
  p->width = width;
  p->height = height;
  p->move_x = move_x;
  p->move_y = move_y;
  return p;
}

void delete_piece(piece p){
  free(p);
}

void copy_piece(cpiece src, piece dst){
  assert(dst != NULL);
  dst->x = src->x;
  dst->y = src->y;
  dst->width = src->width;
  dst->height = src->height;
  dst->move_x = src->move_x;
  dst->move_y = src->move_y;
}

void move_piece(piece p, dir d, int distance){
  if(d == LEFT && p->move_x)
    p->x -= distance;
  if(d == RIGHT && p->move_x)
    p->x += distance;
  if(d == UP && p->move_y)
    p->y += distance;
  if(d == DOWN && p->move_y)
    p->y -= distance;
}

bool intersect(cpiece p1, cpiece p2){
  for(int x1 = 0; x1 < p1->width; x1++){
    for(int y1 = 0; y1 < p1->height; y1++){
      for(int x2 = 0; x2 < p2->width; x2++){
	for(int y2 = 0; y2 < p2->height; y2++){
	  if((p1->x + x1) == (p2->x + x2) && (p1->y + y1) == (p2->y + y2))
	    return true;
	}
      }
    }
  }
  return false;
}

int get_x(cpiece p){
  return p->x;
}

int get_y(cpiece p){
  return p->y;
}

int get_height(cpiece p){
  return p->height;
}

int get_width(cpiece p){
  return p->width;
}

bool is_horizontal(cpiece p){
  return p->move_x;
}

bool can_move_x(cpiece p){
  return p->move_x;
}

bool can_move_y(cpiece p){
  return p->move_y;
}
