#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#include "game.h"
#include "niveau.h"
#include "input_move.h"

//fonction qui prend en paramètre un game, et qui affiche l'état de la partie dans le terminal
void afficher(game g){
  int width = game_width(g);
  int height = game_height(g);
  int matrice[height][width];
  for(int i = 0; i < height; i++){
    for(int j = 0; j < width; j++){
      matrice[i][j] = -1;
    }
  }
  for(int i = 0; i < game_nb_pieces(g); i++){
    cpiece p = game_piece(g, i);
    int x = get_x(p);
    int y = get_y(p);
    matrice[y][x] = i;
    for(int j = 1; j < get_width(p); j++)
      matrice[y][x+j] = i;
    for(int j = 1; j < get_height(p); j++)
      matrice[y+j][x] = i;
  }
  printf(" #############################\n");
  int ligneWin = get_y(game_piece(g, 0));
  for(int i = height-1; i >= 0 ; i--){
    printf("|");
    for(int j = 0; j < width; j++){
      if(matrice[i][j] == -1){
	printf(" .. ");
      } else {
	printf(" %2d ", matrice[i][j]);
      }
      if(j!=width-1 || i!=ligneWin)
	printf("|");
    }
    printf("\n");
  }
  printf(" #############################\n");
  printf("Nombre de déplacement : %d\n", game_nb_moves(g));
}

//fonction qui prend un game et qui va faire jouer l'utilisateur jusqu'a qu'il est réussis
void start_game(game g){
  afficher(g);
  while(!game_over_hr(g)){
    int numPiece = num_piece_mouv(g);
    dir d = direction(g, numPiece);
    int nbCase = nombre_deplacement();
    if(!play_move(g, numPiece, d, nbCase)){
      printf("MOUVEMENT NON VALIDE\n");
    }
    afficher(g);
  }
  printf("Bravo, vous avez fini la partie\n");
}

//fonction qui s'exécute en premier et qui va demander à l'utilisateur le niveau souhaité afin de débuter un partie, et qui fois terminer met fin au programme
int main(void){
  printf("Bienvenue dans rush-hour\n");
  char s[10];
  game g;
  int niveau;
  do{
    printf("Veuillez ecrire le niveau souhaité (1, 2 ou 3) : \n");
    fgets(s, 10, stdin);
    niveau = atoi(s);
  }while(!isNumber(s) || (niveau != 1 && niveau != 2 && niveau != 3));;
  g = create_game_rh(niveau);
  start_game(g);
  delete_game(g);
  return EXIT_SUCCESS;
}
